package com.zipcodewilmington.arrayutility;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility <E> {
    private E[] inputArray;

    public ArrayUtility(E[] inputArray) {
        this.inputArray = inputArray;
    }

    public E[] mergeTwoArrays(E[] first, E[] second) {
        E[] mergedArray = Arrays.copyOf(first, first.length + second.length);
        for (int i = first.length; i < mergedArray.length; ++i) {
            mergedArray[i] = second[i-first.length];
            }
        return mergedArray;
    }

    public Integer countDuplicatesInMerge(E[] arrayToMerge, E valueToEvaluate) {
        E[] mergedArray = mergeTwoArrays(inputArray, arrayToMerge);
        Integer count = 0;
        count = getNumberOfOccurrences(mergedArray,valueToEvaluate);
        return count;
    }

    public int getNumberOfOccurrences(E[] objectArray, E objectToCount) {
        int numberOfOccurrences = 0;
        for(E current : objectArray) {
            if (current.equals(objectToCount)) {
                ++numberOfOccurrences;
            }
        }

        return numberOfOccurrences;
    }

    public int getNumberOfOccurrences(E objectToCount) {
        int numberOfOccurrences = 0;
        for(E current : inputArray) {
            if (current.equals(objectToCount)) {
                ++numberOfOccurrences;
            }
        }

        return numberOfOccurrences;
    }

    public E getMostCommonFromMerge(E[] arrayToMerge) {
        E[] mergedArray = mergeTwoArrays(inputArray, arrayToMerge);
        E mostCommonObject = null;
        int maxNumberOfOccurrences = 0;
        for(E current : mergedArray) {
            int currentNumber = getNumberOfOccurrences(arrayToMerge, current);
            if (currentNumber > maxNumberOfOccurrences) {
                mostCommonObject = current;
                maxNumberOfOccurrences = currentNumber;
            }
        }
        return mostCommonObject;
    }

    public E[] removeValue(E objectToRemove) {
        boolean[] removeObject = new boolean[inputArray.length];
        int sizeOfNewArray = 0;

        for(int i = 0; i < inputArray.length; ++i) {
            if (inputArray[i].equals(objectToRemove)) {
                removeObject[i] = true;
            } else {
                removeObject[i] = false;
                ++sizeOfNewArray;
            }
        }

        E[] arrayWithRemovedObjects = Arrays.copyOf(this.inputArray, sizeOfNewArray);
        int index = 0;

        for(int i = 0; i < inputArray.length; ++i) {
            if (!removeObject[i]) {
                arrayWithRemovedObjects[index] = inputArray[i];
                ++index;
            }
        }
        return arrayWithRemovedObjects;
    }
}
